#!/usr/local/bin/python
import hashlib
import json
import sys
from pyspark.sql import SparkSession
from pyspark.sql.types import StringType
# import os
import pymysql

# os.system("pip install pyspark")
def getMySqlConnect():
    # 连接数据库
    conn = pymysql.connect(
        host="hadoop1",  # 连接主机名,也可以用ip地址，例如127.0.0.1
        user="root",  # 连接用户名
        passwd="123",  # 用户密码
        db="wanjia",  # 要连接的数据库名
        charset="utf8",  # 指定编码格式
        autocommit=True,  # 如果插入数据，， 是否自动提交? 和conn.commit()功能一致。
    )
    return conn

def getRecordByIdResultT1(id):
    conn = getMySqlConnect()
    # 创建游标对象,用来给数据库发送sql语句
    cur = conn.cursor()
    serch_data = """select t1 from test where id = {table_id}""".format(table_id=id)
    result = cur.execute(serch_data)
    # 获取下一个查询结果集
    record = cur.fetchone()
    cur.close()  # 关闭数据库连接
    return record

def getColumns(x):
    sql_list = []
    list = [i for i in json.loads(x).get('col')]
    for i in range(0, len(list)):
        if json.loads(x).get('tm').get(list[i]) == "md5":
            sql_list.append('list[i] as t_'+list[i]+'md5('+list[i]+') as '+list[i])
        elif json.loads(x).get('tm').get(list[i]) == "rtl":
            sql_list.append('list[i] as t_'+list[i]+'rtl('+list[i]+') as '+list[i])
        else:
            print("")
    col = ""
    for i in list:
        if i == list[len(list) - 1]:
            col += i
        else:
            col += i + ' ,'

    sql = "select " + col + ", current_timestamp() as create_time from kino"
    print("---------------------->", sql)
    return sql

def md5(col):
    md5 = hashlib.md5()
    md5.update(str(col).encode('utf-8'))
    return md5.hexdigest()

# 脱敏
id = sys.argv[1]
output_file=sys.argv[2]

if __name__ == '__main__':
    # 拿到 列名 等
    record = getRecordByIdResultT1(id)
    col = json.loads(str(record)[2:-3]).get('col')
    sql = getColumns(str(record)[2:-3])
    print(sql)

    # spark 初始化
    spark = SparkSession.Builder().appName('sql').master('local').getOrCreate()

    spark.udf.register('md5', md5, StringType())
    print('-------->', output_file)
    df = spark.read.format('csv').option('inferSchema', 'true').load(output_file).toDF(*col)
    df.count
    t_table = df.createTempView('kino')
    sinkDF = spark.sql(sql)
    sinkDF.show()

    '''
        :param mode: specifies the behavior of the save operation when data already exists.
        * ``append``: Append contents of this :class:`DataFrame` to existing data.
        * ``overwrite``: Overwrite existing data.
        * ``ignore``: Silently ignore this operation if data already exists.
        * ``error`` or ``errorifexists`` (default case): Throw an exception if data already exists.
        '''
    sinkDF.write.mode("overwrite") \
        .format("jdbc") \
        .option("truncate", "true") \
        .option("batchsize", 10000) \
        .option("isolationLevel", "NONE") \
        .option("driver", "org.mariadb.jdbc.Driver") \
        .option("url", 'jdbc:mysql://hadoop1:3306/wanjia?useSSL=false') \
        .option("user", 'root') \
        .option("password", '123') \
        .option("dbtable", "test1") \
        .save()

    # TODO 修改状态

    # 落 ftp
    # sinkDF.write.format("com.springml.spark.sftp")  \
    #     .option("host", "192.168.31.45") \
    #     .option("username", "raomin@9zdata.cn") \
    #     .option("password", "9zdata123.") \
    #     .option("fileType", "csv") \
    #     .option("delimiter", ";") \
    #     .save("ftp://192.168.31.45:21/wanjia/sample.csv")
    sinkDF.write.mode("overwrite").text("ftp://192.168.31.45/wanjia/sample.csv")

    # sinkDF.write.format("parquet").mode("overwrite").save('hdfs://hadoop1:9000/wanjia')



    # 关闭spark会话
    spark.stop()






