#!/usr/local/bin/python
import sys
import os
import shutil
import zipfile

from wanjia.spark.common import Constants
from wanjia.spark.sources import Sources as sources

# pyName = sys.argv[0]  # sys.argv[0] 类似于shell中的$0, 但不是脚本名称，而是脚本的路径
# zipPath = sys.argv[1]  # sys.argv[1] 表示传入的第一个参数
# inputPath = sys.argv[2]  # sys.argv[2] 表示传入的第二个参数
# outputPath = sys.argv[3]
# os.system("hdfs dfs -put /srcPath /dstPath")

def unzip_single(srcPath, dstPath):
    ''' 解压单个文件到目标文件夹。
    '''
    zf = zipfile.ZipFile(srcPath)
    try:
        zf.extractall(path=dstPath)
    except FileNotFoundError as e:
        print("zipPath not exists:{0}".format(e))
    zf.close()


def unzip_all(source_dir, dest_dir):
    if not os.path.isdir(source_dir):  # 如果是单一文件
        unzip_single(source_dir, dest_dir)
    else:
        it = os.scandir(source_dir)
        for entry in it:
            if entry.is_file() and os.path.splitext(entry.name)[1] == '.zip':
                unzip_single(entry.path, dest_dir)


def copy_file(srcPath, dstPath):

    if not os.path.exists(srcPath):
        os.mkdir(srcPath)
        print("srcPath mkdir success")
        if not os.path.exists(dstPath):
            os.mkdir(srcPath)
            print("dstPath mkdir success")
    else:
        for root, dirs, files in os.walk(srcPath, True):
            for fileName in files:
                if fileName.endswith('.csv'):
                    shutil.copy(os.path.join(root, fileName), dstPath)

if __name__ == '__main__':

    try:
        # unzip_all(source_dir, dest_dir)
        # copy_file(srcPath, dstPath)
        unzip_all("D:\\ftp.zip", "D:\\dst")
        copy_file("D:\\dst", "D:\\dt")
    except FileNotFoundError as e:
        print("unzip failed:{0}".format(e))
        status = Constants.COPY_FILE_CODE
        sources.updateStatusById(status)

