import sys
sys.path.append('/root/dmp/etl_process_data/etl_job')
import modifyStatus, DbUtils, constants, MyFTP
import time
import os
import logging as logger

localTime = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
print(localTime)
"""
通过传入的记录获取需要的字段
"""

def getColumns(column,hdfs_csv_path):
    """
    :param hdfs_csv_path: 上传到hdfs的csv路径
    :param column: 数据库查询出来的记录
    :return:       具体需要的字段
    """

    try:
        # 遍历后判断是否为None,如果为None就用原始字段,如果不为None就用用户修改的字段
        # 使用 list_cols 存储
        list_cols = [[] for i in range(len(column))]
        for i in range(0, len(column)):
            if column[i][2] is not None:
                list_cols[i].append(column[i][2])
            else:
                list_cols[i].append(column[i][0])
            if column[i][3] is not None:
                list_cols[i].append(column[i][3])
            else:
                list_cols[i].append(column[i][1])
            list_cols[i].append(column[i][4])
        #  all columes
        col = ""
        #  rule columes
        col_file = ""
        col_create = ""
        col_list = []
        #  clean_up rule
        for i in range(0, len(list_cols)):
            if list_cols[i][2] == "md5" or list_cols[i][2] == "base64":
                col += list_cols[i][2] + '(' + list_cols[i][0] + ') as ' + list_cols[i][0] + ", " + list_cols[i][
                    0] + ' as t_' + list_cols[i][0] + ', '
                col_file += list_cols[i][0] + ', '
                col_list.append(list_cols[i][0])
                col_list.append('t_' + list_cols[i][0])
            else:
                col += list_cols[i][0] + ', '
                col_file += list_cols[i][0] + ', '
                col_list.append(list_cols[i][0])
            col_create += list_cols[i][0] + " string, "
        create_tmp_sql = 'create table dmp_demo.impala_tmp as select %s from %s' % (col[0:-2], 'dmp_demo.a')
        md5_sql = 'select %s from %s' % (col_file[0:-2], 'dmp_demo.impala_tmp')
        impala_sql = ""
        for i in range(0, len(col_list)):
            if i < 10:
                impala_sql += col_list[i] + " as c0" + str(i + 1) + ", "
            else:
                impala_sql += col_list[i] + " as c" + str(i + 1) + ", "
        impala_sql = 'insert into %s as select %s from %s' % ("dmp_demo.impala_table", impala_sql[0:-2], 'dmp_demo.impala_tmp')
        create_sql = 'create external table dmp_demo.a (%s) row format delimited fields terminated by \',\' ' \
                     'location \\"%s\\" tblproperties(\\"skip.header.line.count\\"=\\"1\\")' % (col_create[0:-2], hdfs_csv_path)
        print("=======> load csv sql：", create_sql)
        print("=======> create impala external table sql：", create_tmp_sql)
        print("=======> tuomin sql：", md5_sql)
        print("=======> output impala sql：", impala_sql)
        return [create_sql, create_tmp_sql, md5_sql, impala_sql]
    except  Exception as e:
        logger.error("json parse exception:{0}".format(e))

        # 更新文件处理状态：正在处理中...，列名解析异常
        modifyStatus.updateStatusById(constants.FILE_PROCESSING, constants.PARSE_COLS, e, localTime,
                                      constants.SP_UPDATE_PERSON, file_id,constants.FILE_TABLE_NAME)
        sys.exit(1)

if __name__ == '__main__':
    if len(sys.argv)<3:
        print("=======> python arguments is 3 but arguments pass %s" %len(sys.argv))
    else:
        file_id = sys.argv[1]
        hdfs_path = sys.argv[2]
    # 更新文件处理状态：正在处理中...
    modifyStatus.updateStatusById(constants.FILE_PROCESSING,constants.DEFAULT_FILE_STATUS,
                                  constants.DEFAULT_ERROR_INFO,localTime,constants.ZMH_UPDATE_PERSON,
                                  file_id,constants.FILE_TABLE_NAME)
    try:
        db, cursor = DbUtils.create_conn()
        cursor = db.cursor()
        get_col_info_sql = '''select field_name,field_type,modify_field_name,modify_field_type,clean_rule
                          from t_file_save_field_info where file_deposit = ''' + str(file_id)
        cursor.execute(get_col_info_sql)
        cols = cursor.fetchall()
        db.commit()
    except Exception as e:
        logger.error("file treatment get columns and types exception:{0}".format(e))
        # 更新文件处理状态：正在处理中...，连接数据库获取文件字段、类型异常
        modifyStatus.updateStatusById(constants.FILE_PROCESSING, constants.GET_COL_FAILE, e, localTime,
                                      constants.SP_UPDATE_PERSON, file_id, constants.FILE_TABLE_NAME)
        sys.exit(1)

    list_sqls = getColumns(cols,hdfs_path)

    try:
        #  创建原始csv外部表
        os.system('impala-shell -q "drop table if exists dmp_demo.a"')
        os.system('impala-shell -q "%s"' % (list_sqls[0]))
        #  创建临时表(字段反转、及脱敏后数据)
        os.system('impala-shell -q "drop table if exists dmp_demo.impala_tmp"')
        os.system('impala-shell -q "%s"' % (list_sqls[1]))
        query = list_sqls[2]
        #  临时表 insert 进 impala_table
        # os.system('impala-shell -q "%s"' % (list_sqls[3]))
        #  临时表落csv(仅脱敏后的数据)
        dir = '/root/dmp/etl_process_data/csv_path/user_info.csv'
        os.system("rm -f %s" % dir)
        os.system('impala-shell -B -q "%s" -o %s \'--output_delimiter=,\'' % (query, dir))
    except Exception as e:
        logger.error("csv load and impala create exception:{0}".format(e))
        #  更新文件处理状态：正在处理中...，csv落表异常
        modifyStatus.updateStatusById(constants.FILE_PROCESSING, constants.CSV_TABLE_FILE, e, localTime,
                                      constants.SP_UPDATE_PERSON, file_id, constants.FILE_TABLE_NAME)
        sys.exit(1)

    try:
        #  upload file to ftp
        host_address = "192.168.153.1"
        username = "sp"
        password = "sp940219sp"
        my_ftp = MyFTP(host_address)
        my_ftp.login(username, password)
        my_ftp.upload_file("/root/dmp/etl_process_data/csv_path/user_info.csv",
                           "/opt/dmp/dmp_etlprocesses/ftp_data/csv_ftp/user_info_upload.csv")
        my_ftp.close()
    except Exception as e:
        logger.error("csv output to ftp exception:{0}".format(e))
        #  更新文件处理状态：正在处理中...，csv落ftp异常
        modifyStatus.updateStatusById(constants.FILE_PROCESSING, constants.CSV_TO_FTP_FILE, e, localTime,
                                      constants.SP_UPDATE_PERSON, file_id, constants.FILE_TABLE_NAME)
        sys.exit(1)
    #   更新文件处理状态：文件处理完成
    modifyStatus.updateStatusById(constants.FILE_PROCESSING_FINISH, constants.FINAL_RESULT_SUCCESS, "成功", localTime,
                                  constants.ZMH_UPDATE_PERSON, file_id,constants.FILE_TABLE_NAME)
