import datetime
import getpass
import glob
import os
import shutil
import zipfile
import sys
import pandas as pd
import numpy as np
import re
import pymysql

def unzip_all(source_dir, dest_dir):
    try:
        it = os.scandir(source_dir)
        for entry in it:
            if entry.is_file() and os.path.splitext(entry.name)[1] == '.zip':
                if not os.path.exists(dest_dir):
                    os.mkdir(dest_dir)
                    zipfile.ZipFile(entry.path).extractall(path=dest_dir)
                else:
                    zipfile.ZipFile(entry.path).extractall(path=dest_dir)
    except Exception as e:
        print("unzip_all error:{0}".format(e))

def copy_file(srcPath, dtPath):
    success_code=0
    try:
        for root, dirs, files in os.walk(srcPath, True):
            for fileName in files:
                if fileName.endswith('.csv'):
                    shutil.copy(os.path.join(root, fileName), dtPath)
        success_code = 1
        return success_code
    except Exception as e:
        print("copy_file error:{0}".format(e))


def analysis_csv(file_id,csv_path):
    csvFiles = glob.glob(csv_path + "/*")
    list_ = []
    list_error_file = []
    for files in csvFiles:
        try:
            df = pd.read_csv(files, index_col=None, header=0)
            list_.append(df)
        except Exception as e:
            list_error_file.append(files)
            continue
    data = pd.concat(list_, ignore_index=True)
    print(data)
    ten_json = data.head(2).to_json(orient='index')
    update_sql = "update t_file_pretreatment_status set explore_json='" + ten_json +"' where file_deposit=" + file_id

    # 剔除所有值前后空格
    stripstr = lambda x: x.strip() if isinstance(x, np.unicode) else x
    data = data.applymap(stripstr)
    for i in data.keys():
        col = str(data[i][0])
        compile1 = re.compile('\d{4}[-/.]\d{1,2}[-/.]\d{1,2}\s\d{1,2}:\d{1,2}:\d{1,2}|\d{4}[-/.]\d{1,2}[-/.]\d{1,2}')
        match_all = compile1.findall(col)
        if len(match_all) != 0:
            if len(col) == 19:
                data[i] = pd.to_datetime(data[i])
            elif len(col) == 10:
                data[i] = pd.to_datetime(data[i])
    str_col=""
    for i in range(0,len(data.dtypes)):
        str_col += "(" + str(file_id) + ", '" + str(data.columns.values[i]) + "', '" + str(data.dtypes[i]) + \
                   "', '" + str(datetime.datetime.now()) + "', '" + str(getpass.getuser()) + "'),"
    insert_sql = "insert into t_file_save_field_info (file_deposit,field_name,field_type,cre_time,cre_person) values " + str_col
    return list_error_file, update_sql, insert_sql[0:-1]

if __name__ == '__main__':
    get_file_deposit_info=sys.argv
    print(get_file_deposit_info)
    get_file_id=get_file_deposit_info[1]
    get_ftp_path=get_file_deposit_info[3]
    get_output_hdfs_path=get_file_deposit_info[5]
    get_unzip_output_path=get_file_deposit_info[6]
    get_copy_output_path=get_file_deposit_info[7]
    unzip_all(get_ftp_path, get_unzip_output_path)
    su_code=copy_file(get_unzip_output_path, get_copy_output_path)
    if su_code==1:
        os.system("hdfs dfs -rm -r /user/tuomin_test")
        os.system("hdfs dfs -mkdir /user/tuomin_test")
    pre_list = analysis_csv(get_file_id,get_copy_output_path)
    print("csv无法读取的文件list：" + str(pre_list[0]))
    print("十条json数据更新sql：" + str(pre_list[1]))
    print("数据字段写入sql：" + str(pre_list[2]))

    db = pymysql.connect("192.168.1.90", "root", "root", "demo_test")
    cursor = db.cursor()
    cursor.execute(pre_list[1])
    cursor.execute(pre_list[2])
    db.commit()
    db.close()


